// License: GNU General Public License (GPL)
// Copyright (c) 2008 NIPPON TELEGRAPH AND TELEPHONE CORPORATION

public class commandLine {
	static int	oneShotOption = 0, intervalOption = 0, intervalTime = 0;

	commandLine(String[] args) {

		if (args.length == 0) {
            intervalOption = 1;
            intervalTime = 15;
        } else {
            for (int i = 0; i < args.length; i ++) {
                if ("-1".equals(args[i]))  oneShotOption = 1;
                else if ("-i".equals(args[i])) {
                    intervalOption = 1;
                    try {
                        intervalTime = Integer.parseInt(args[++i]);
                        if (intervalTime <= 0 || intervalTime > 3600) {
                            System.out.println("時間は1以上, 3600以下の数字を指定してください");
                            usage();
                        }
                    } catch (java.lang.NumberFormatException nfe) {
                        System.out.println("時間の指定に数字以外が指定されています");
                        usage();
                    } catch (java.lang.ArrayIndexOutOfBoundsException aioe) {
                        System.out.println("-i の後には数字の指定が必要です。");
                        usage();
                    }
                } else usage();
         	}
		}

    	if (oneShotOption == 1 && intervalOption == 1) usage();
	}

    public static void usage(){
        System.out.println("unage: failstate [-1?i:]");
        System.out.println("    -?           :help この文書の表示 ");
        System.out.println("    -1           :one-shot  一度だけ表示 ");
        System.out.println("    -i <seconds> :指定された秒間隔で状態を表示");
        System.out.println("-iオプションと-1オプションを同時に指定することはできません");
        System.out.println("オプションの指定がない場合は15秒毎に繰り返し状態を表示します");
        Runtime.getRuntime().exit(1);
    }

	/* 以下は単体テスト用。結合する際はコメントアウトすること。		 */
/*
	public static void main(String[] args) {
		commandLine cl = new commandLine(args);
		System.out.println("oneShotOption  = " + oneShotOption);
		System.out.println("intervalOption = " + intervalOption);
		System.out.println("intervalTime   = " + intervalTime);
	}
*/
}

