// License: GNU General Public License (GPL)
// Copyright (c) 2008 NIPPON TELEGRAPH AND TELEPHONE CORPORATION

import java.io.*;
import java.util.*;

/**
 * /etc/ha.d/ha.cfからpingdの設定を取得するクラス
 * @author OKADA Satoshi
 * @version 1.1
 */


public class pingdFromHacf {
	static ArrayList pingNodeList = new ArrayList(); 
	static Hashtable pingdOptions = new Hashtable();
	ArrayList rdList = new ArrayList(); 
	static final String HACF_PATH = "/etc/ha.d/ha.cf";

	pingdFromHacf() {
		final String PING = "ping";
		final String COMMENT = "#";
		final String RESPAWN = "respawn";
		final String PINGD = "pingd";

		try {
			FileInputStream haconf = new FileInputStream(HACF_PATH);
			InputStreamReader in = new InputStreamReader(haconf);
			BufferedReader br = new BufferedReader(in);
			String msg;
			String[] pingNode;
			String[] rd; 
			
			while ((msg = br.readLine()) !=  null) {
				msg = msg.trim(); 				//前後の空白を取り除く
				msg = msg.replace('\t',' '); 	//文字列に含まれるTabを空白文字に変換

				// ping ディレクティブを取得
				if (msg.startsWith(PING) ) { 
					// System.out.println("pingd directive found");
					pingNode = msg.split(" ");
					for (int i = 1; i < pingNode.length; i ++) {
						if ((pingNode[i].length()) >= 1 && 
						  !(pingNode[i].startsWith(COMMENT)) ) {
						    pingNodeList.add(pingNode[i]);
						}
					}
				}

				// respawn ディレクティブの取得
				if (msg.startsWith(RESPAWN)) {
					// System.out.println("respawn directive found");
					rd = msg.split(" ");
					for (int i = 0; i < rd.length; i++) {
						if ((rd[i].length()) >= 1) {
							if (rd[i].startsWith(COMMENT)) break;
						    rdList.add(rd[i]);
						}
					}
				} 
				// pingdの設定からオプションを取得し、hashTableに格納
				if (rdList.size() >= 1) {
					String work = (String)rdList.get(2);
					if (work.endsWith(PINGD)) {
				    	for (int i = 3; i < rdList.size(); i+=2 ) {
							pingdOptions.put(rdList.get(i), rdList.get(i + 1));
						}
					}
				}
				rdList.clear(); 	// サイズを0に
			}
			in.close();
		} catch (FileNotFoundException fnfe) {
			System.out.println(HACF_PATH+"ファイルがありません。確認してください");
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/** 
	 pingdの起動オプションの値を取得し、返却
	 @param option pingdの起動オプション
	 @return オプションの値
	 */
	public static String getValue(String option) {
		return (String)pingdOptions.get(option);
	}

	/** 
	 ha.cf内のping指定で指定されたノードの数
	 */
	public static int numOfPingNode() {
		return pingNodeList.size();
	}
	
	/* 以下、単体テスト用メソッド群。テスト時以外はコメントアウトすること */
/*
	private static void showAllOptions(){
		System.out.println("** pingd options **");
		System.out.println("  number of pingd option(s) = " + pingdOptions.size());
		System.out.println("  "+pingdOptions.toString());
	}

	private static void showAllPingNodes(){
		System.out.println("** ping nodes **");
		System.out.println("  number of ping node(s) = " + numOfPingNode());
		for (int i = 0; i < pingNodeList.size() ; i++) {
			System.out.println("    node("+i+") = "+pingNodeList.get(i));
		}
	}

	public static void main(String[] args){
		System.out.println("** ha.cf path **");
		pingdFromHacf pfh = new pingdFromHacf();
		System.out.println("  ha.cf path = " + HACF_PATH);
		showAllPingNodes();
		showAllOptions();
	}
*/

}

